#version 130 // GLSL verzia

uniform sampler2D base_tex_unit;  // zakladna textura
uniform sampler2D bloom_tex_unit; // bloom textura

uniform vec3 bloom; // parametre bloom - factor, bright, exposure

// prenasane udaje
in vec2 uv;

void main(void)
{
 vec4 color=texture(base_tex_unit,uv);
 vec4 bloomcolor=texture(bloom_tex_unit,uv);

 // bloom
 color+=bloomcolor*bloom.x;

 // tone-mapping
 float Y=dot(vec4(0.30,0.59,0.11,0.0),color);
 float YD=bloom.z*((bloom.z/bloom.y+1.0)/(bloom.z+1.0));
 color*=YD;

 gl_FragColor=color;
}
