#version 150 // GLSL verzia

uniform sampler2D base_tex_unit; // zakladna textura

// vstupne udaje z geometry shadera
in block
{
 vec3 nor;
 vec2 uv;
 vec3 dir_to_light,dir_to_eye;
 float dist;
 vec4 ambient,diffuse,specular;
} forFS;

void main(void)
{
 vec4 color,amb,dif=vec4(0.0),spe=vec4(0.0);
 vec3 N,L,E,RV;
 float NdotL,att=0.0,spot;

 // farba z textury
 color=texture(base_tex_unit,forFS.uv);

 // ambient
 amb=color*forFS.ambient;

 // normalizacia interpolovanych udajov
 N=normalize(forFS.nor);
 L=normalize(forFS.dir_to_light);

 NdotL=max(dot(N,L),0.0);
 if (NdotL>0.0) {
  spot=dot(gl_LightSource[0].spotDirection,-L);
  if (spot>gl_LightSource[0].spotCosCutoff) {
   // utlm
   att=pow(spot,gl_LightSource[0].spotExponent)/
       (gl_LightSource[0].constantAttenuation+
        gl_LightSource[0].linearAttenuation*forFS.dist+
        gl_LightSource[0].quadraticAttenuation*forFS.dist*forFS.dist);

   // diffuse
   dif=NdotL*forFS.diffuse;

   // specular
   E=normalize(forFS.dir_to_eye);
   RV=normalize(-reflect(L,N)); // reflect vector
   spe=pow(max(dot(E,RV),0.0),gl_FrontMaterial.shininess)*forFS.specular;
  }
 } else amb*=0.5;

 // vysledna farba
 gl_FragColor=amb+att*(dif+spe);
}
